#!./strawberry

include("banners.pro").

?-
  G_K = m,
  G_Depth = 3,
  G_N = 8, G_Val = 50, G_Clicked=1,
  I is scan(get_environment_arg(0, getenv("QUERY_STRING"))),
  J is scan(get_environment_arg(1, getenv("QUERY_STRING"))),
  B1 is scan(get_environment_arg(2, getenv("QUERY_STRING"))),
  W1 is scan(get_environment_arg(3, getenv("QUERY_STRING"))),
  C is scan(get_environment_arg(4, getenv("QUERY_STRING"))),
  C=[X,Y],
  Px is (X>20-> 1 else -1),
  Py is (Y>20-> 1 else -1),
  X2 is I+Px,
  Y2 is J+Py,
  G_X3 is I+2*Px,
  G_Y3 is J+2*Py,
  elem([K,I,J],W1),
  set(pos(b,B1,W1)),
  ((G_X3>=0,G_X3<8,G_Y3>=0,G_Y3<8,take(K,I,J,G_X3,G_Y3,B1,W1);
    X2>=0,X2<8,Y2>=0,Y2<8,not(can(W1,B1,W1)),step(K,I,J,X2,Y2,B1,W1))->
    pos(_,B2,W2),
    (isFinal(B2,W2,_)->
      G_Clicked:= -1),
    say(B1,W1,B2,W2)
  else
    S is "You try to move "
        + (Py=1->"down" else "up")+"-"
        + (Px=1->"right" else "left")+" the "
        + (K=k->"king" else "pawn")+" which is on "+string_from_ASCII(first_ASCII("A")+I)+ (8-J)
        +".<br><br>This is impossible",
    ((X2<0;X2>7;Y2<0;Y2>7)->
      S2 is S +" because you will run out of the table."
    else (can(W1,B1,W1)->
      S2 is S +" because you are obliged to pick when you can."
    else
      S2 is S +"."
    )),
    problem(S2)
  ).

say(B1,W1,B2,W2):-
  set_content_type("text/html"),
  write(`
<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
   <meta name="Author" content="Dimiter Dobrev">
   <meta name="GENERATOR" content="Mozilla/4.51 [en] (Win98; I) [Netscape]">
   <title>Checkers</title>`),
  (G_Clicked=1->
    write(`
<META HTTP-EQUIV="Refresh"  Content = "2;  URL=/cgi-bin/Checkers.pro?`),  
    write(B2), write("&"),  
    write(W2), write(`">`)
  ),
  write(`
</head>
<body text="#FFFFCC" bgcolor="#282848" link="#FF0000" vlink="#FF9900" alink="#FFCC33" background="/backgr.gif">
&nbsp;
<center><table BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="360" >
<tr>
<td><img SRC="/games/Checkers/ramka_up.gif" height=20 width=360></td>
</tr>`),
  make_table(B1,W1,B2,W2),
  write(`
<tr>
<td><img SRC="/games/Checkers/ramka_dn.gif" height=20 width=360></td>
</tr>
</table></center>

<center>
<p><font size=+1>`),
  (G_Clicked= -1 ->
    write(`Game over. You win.`)
  else (G_Clicked>1->
    write(`Well, pick again.`)
  else
    write(`Please, wait a little bit.`)
  )),
write(`</font>
<p><a href="/games/Checkers/Checkers.html"><img SRC="/games/NewGame_up.gif" ALT="New Game" NOSAVE BORDER=0 height=39 width=101></a><a href="/games.html"><img SRC="/games/BacktoGames_up.gif" ALT="Back To Games" NOSAVE BORDER=0 height=39 width=132></a><a href="/games/Rules_Checkers.html"><img SRC="/games/Rules_up.gif" ALT="Rules" NOSAVE BORDER=0 height=39 width=63></a><a href="/"><img SRC="/games/SP_up.gif" ALT="Strawberry Prolog" NOSAVE BORDER=0 height=39 width=101></a>
<p><b><font color="#33CCFF"><font size=+3>Checkers</font></font></b></center>

<p><br>`),
  banner,
  write(`
<br>
</body>
</html> 
 
`). 

problem(S):-
  set_content_type("text/html"),
  write(`<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="Author" content="Dimiter Dobrev">
   <title>Invalid Move</title>
</head>
<body text="#FFFFCC" bgcolor="#282848" link="#FF0000" vlink="#FF9900" alink="#FFCC33" background="/backgr.gif">

<center><b><font color="#33CCFF"><font size=+3>This move is not correct!</font></font></b></center>

<br><b><font color="#33CCFF"><font size=+2></font></font></b>&nbsp;
<center><table CELLSPACING=0 CELLPADDING=0 WIDTH="100%%" >
<tr>
<td><b><font size=+2>`),
  write(S),
  write(`</font></b></td>

<td>
<div align=right><img SRC="/Forms/catstop.gif" height=110 width=110></div>
</td>
</tr>
</table></center>
<p><font size=+1>Press back button of your browser to return to the previous
page and to play another move.</font>
<br><br><br>&nbsp;`),
  banner,
  write(`
<br>&nbsp;
</body>
</html>
`).

make_table(B1,W1,B2,W2):-
  for(J,0,7),
  write(`
<tr>
<td><img SRC="/games/Checkers/ramka_`),write(8-J),write(`.gif" BORDER=0 height=40 width=20>`),
  make_line(J,B1,W1,B2,W2),
  write(`<img SRC="/games/Checkers/ramka_`),write(8-J),write(`.gif" BORDER=0 height=40 width=20></td>
</tr>`),
  fail.
make_table(|_).

make_line(J,B1,W1,B2,W2):-
  for(I,0,7),
	draw(I,J,B1,W1,B2,W2),
	fail.
make_line(|_).


draw(I,J,B1,W1,B2,W2):-
  (I+J) mod 2=:=0 ->
    write(`<img SRC="/games/Checkers/sqr_w.gif" BORDER=0 height=40 width=40>`)
  else (G_Clicked>1, I=G_X3, J=G_Y3, elem([F,I,J], W2)->
    write(`<a href="/cgi-bin/Checkers2.pro?`),  
    write(I), write("&"),  
    write(J), write("&"),  
    write(B2), write("&"),  
    write(W2), write(`">`),
    write(`<img SRC="/games/Checkers/`),write(F),write(`_r_fl.gif" ismap BORDER=0 height=40 width=40>`)
  else (elem([F,I,J], W2)->
   (elem([F,I,J], W1)->
     write(`<img SRC="/games/Checkers/`),write(F),write(`_r_n.gif" BORDER=0 height=40 width=40>`)
   else
     write(`<img SRC="/games/Checkers/`),write(F),write(`_r_dn.gif" BORDER=0 height=40 width=40>`)
   )
  else (elem([F,I,J], B2)->
    write(`<img SRC="/games/Checkers/`),write(F),write(`_b_n.gif" ismap BORDER=0 height=40 width=40></a>`)
  else (elem([F,I,J], W1)->
    write(`<img SRC="/games/Checkers/`),write(F),write(`_r_up.gif" BORDER=0 height=40 width=40>`)
  else (elem([F,I,J], B1)->
    write(`<img SRC="/games/Checkers/`),write(F),write(`_b_tr.gif" BORDER=0 height=40 width=40>`)
  else
    write(`<img SRC="/games/Checkers/sqr_b.gif" BORDER=0 height=40 width=40>`)
  ))))).

%********************** Logic Part ***************************************
%*********** Can must check whether the player can take a pul(che) *******
can([H|L],B,W):-elemOfelem(_,X,Y,H),Y1 is Y+2,Y2 is Y- 2,X1 is X+2,X2 is X- 2,
(in(X1,Y1),t(X,Y,X1,Y1,B,W);in(X1,Y2),t(X,Y,X1,Y2,B,W);
 in(X2,Y1),t(X,Y,X2,Y1,B,W);in(X2,Y2),t(X,Y,X2,Y2,B,W)),G_Clicked:=1.
can([H|L],B,W):-can(L,B,W).
%********************** HodW(hite) ***************************************
dir(w,-1).
dir(b,1).
%******************** checks whether a point [X,Y] is in table.***********
in(X,Y):-X>=0,X<G_N,Y>=0,Y<G_N.
%*************************************************************************
hodW(C,K,X1,Y1,X2,Y2,B,W):-
(take(K,X1,Y1,X2,Y2,B,W);can(W,B,W);dir(C,D),step(K,X1,Y1,X2,Y2,B,W)).

t(X1,Y1,X2,Y2,B,W):-
	abs(X2-X1)=:=2,abs(Y2-Y1)=:=2,
	not(elem([_,X2,Y2],B)),not(elem([_,X2,Y2],W)),
	Y is (Y1+Y2)//2,X is (X1+X2)//2,elem([_,X,Y],B).

take(K,X1,Y1,X2,Y2,B,W):-t(X1,Y1,X2,Y2,B,W),
	Y is (Y1+Y2)//2,X is (X1+X2)//2,
	remove([_,X1,Y1],W,W1),
	(Y2=0->addB([k,X2,Y2],W1,W2);
		addB([K,X2,Y2],W1,W2)),
	remove([_,X,Y],B,B1),
	set(pos(w,B1,W2)),
	cantake(K,X2,Y2).
%************************* Checkes whether the player can take again *****
cantake(K,X,Y):-pos(C,B,W),Y1 is Y+2,Y2 is Y- 2,X1 is X+2,X2 is X- 2,
	(in(X1,Y1),t(X,Y,X1,Y1,B,W),++(G_Clicked),G_X := X,G_Y := Y,G_K:=K;
	in(X1,Y2),t(X,Y,X1,Y2,B,W),++(G_Clicked),G_X := X,G_Y := Y,G_K:=K;
	in(X2,Y1),t(X,Y,X2,Y1,B,W),++(G_Clicked),G_X := X,G_Y := Y,G_K:=K;
	in(X2,Y2),t(X,Y,X2,Y2,B,W),++(G_Clicked),G_X := X,G_Y := Y,G_K:=K).
cantake(K,X,Y):-G_Clicked := 1.
%************************* Makes a single step ***************************
step(k,X1,Y1,X2,Y2,B,W):-
	abs(Y2-Y1)=:=1,abs(X2-X1)=:=1,
	not(elem([_,X2,Y2],B)),not(elem([_,X2,Y2],W)),
	remove([k,X1,Y1],W,W1),
	addB([k,X2,Y2],W1,W2),
	set(pos(w,B,W2)).

step(m,X1,Y1,X2,Y2,B,W):-
Y2=:=Y1- 1,abs(X2-X1)=:=1,
not(elem([_,X2,Y2],B)),not(elem([_,X2,Y2],W)),
	remove([m,X1,Y1],W,W1),	
	(Y2=0->addB([k,X2,Y2],W1,W2);
		 addB([m,X2,Y2],W1,W2)),
	set(pos(w,B,W2)).
%**********************************
winB(Depth,B,W,X):- isFinal(B,W,X),!.
winB(Depth,B,W,X):- Depth<1,eval(B,W,X),!.
winB(Depth,B,W,X):-can(B,W,B),P is 2,X := -32000,
	( nextcanB(B1,W1,B,W),D is Depth- 1,winW(D,B1,W1,X1),
	(X1=X -> (Depth=G_Depth ->R:=random(P),++(P),R<1,set(pos(w,B1,W1)))),
	(X1>X -> X:=X1,( Depth=G_Depth->set(pos(w,B1,W1)))),fail;true),!.
winB(Depth,B,W,X):-X := -32000,P is 2,
	( nextstepB(B1,B,W),D is Depth- 1,winW(D,B1,W,X1),
	(X1=X -> (Depth=G_Depth ->R:=random(P),++(P),R<1,set(pos(w,B1,W)))),
	(X1>X -> X:=X1,( Depth=G_Depth->set(pos(w,B1,W)))),fail; 
	(Depth<G_Depth, X= -32000 -> X:=0)),!.

 
winW(Depth,B,W,X):- isFinal(B,W,X),!.
winW(Depth,B,W,X):- Depth < 1,!,eval(B,W,X).
winW(Depth,B,W,X):-can(W,B,W),X := 32000,
	(nextcanB(W1,B1,W,B),D is Depth- 1,winB(D,B1,W1,X1),
	(X1<X -> X:=X1),fail;true),!.
winW(Depth,B,W,X):-X := 32000,
	(nextstepW(W1,B,W),D is Depth- 1,winB(D,B,W1,X1),
	(X1<X -> X:=X1),fail; (X=32000->X:=0)),!.
%********************** Next(s) ******************************************
nextcanB(P,Q,B,W):-elem(Z,B),elemOfelem(K,X,Y,Z),
	elem(T,[2,-2]),elem(F,[2,-2]),X1 := X+T,Y1 := Y+F,
	in(X1,Y1),t(X,Y,X1,Y1,W,B),X2 is (X+X1)//2,Y2 is (Y+Y1)//2,
	remove([_,X,Y],B,B1),remove([_,X2,Y2],W,W1),
	(Y1=7->K1 is k;K1 is K),addB([K1,X1,Y1],B1,B2),
	cantakeB(P,Q,B2,W1,X1,Y1,K1).
cantakeB(P,Q,B,W,X,Y,K):-elem(T,[-2,2]),elem(F,[-2,2]),
	X1 is X+T,Y1 is Y+F,in(X1,Y1),t(X,Y,X1,Y1,W,B),
	X2 is (X+X1)//2,Y2 is (Y+Y1)//2,
	remove([_,X,Y],B,B1),remove([_,X2,Y2],W,W1),
	(Y1=7->K1 is k;K1 is K),addB([K1,X1,Y1],B1,B2),
	cantakeB(P,Q,B2,W1,X1,Y1,K1),!.
cantakeB(B,W,B,W,X,Y,K).

nextcanW(P,Q,W,B):-elem(Z,B),elemOfelem(K,X,Y,Z),
	elem(T,[2,-2]),elem(F,[2,-2]),X1 := X+T,Y1 := Y+F,
	in(X1,Y1),t(X,Y,X1,Y1,W,B),X2 is (X+X1)//2,Y2 is (Y+Y1)//2,
	remove([_,X,Y],B,B1),remove([_,X2,Y2],W,W1),
	(Y1=0->K1 is k;K1 is K),addB([K1,X1,Y1],B1,B2),
	cantakeW(P,Q,B2,W1,X1,Y1,K1).
cantakeW(P,Q,W,B,X,Y,K):-elem(T,[-2,2]),elem(F,[-2,2]),
	X1 is X+T,Y1 is Y+F,in(X1,Y1),t(X,Y,X1,Y1,W,B),
	X2 is (X+X1)//2,Y2 is (Y+Y1)//2,
	remove([_,X,Y],B,B1),remove([_,X2,Y2],W,W1),
	(Y1=0->K1 is k;K1 is K),addB([K1,X1,Y1],B1,B2),
	cantakeW(P,Q,B2,W1,X1,Y1,K1),!.
cantakeW(B,W,W,B,X,Y,K).
%********************** 
nextstepB(P,B,W):-elem(Z,B),elemOfelem(K,X,Y,Z),
	elem(T,[1,-1]),X1 is X+T,Y1 is Y+1,(
	in(X1,Y1),not(elem([_,X1,Y1],B)),not(elem([_,X1,Y1],W)),
	remove([_,X,Y],B,P1),
	(Y1=7->addB([k,X1,Y1],P1,P);addB([K,X1,Y1],P1,P));
	K=k,Y2 is Y- 1,
	in(X1,Y2),not(elem([_,X1,Y2],B)),not(elem([_,X1,Y2],W)),
	remove([_,X,Y],B,P1),addB([k,X1,Y2],P1,P)).

nextstepW(P,W,B):-elem(Z,B),elemOfelem(K,X,Y,Z),
	elem(T,[1,-1]),X1 is X+T,Y1 is Y- 1,(
	in(X1,Y1),not(elem([_,X1,Y1],B)),not(elem([_,X1,Y1],W)),
	remove([_,X,Y],B,P1),
	(Y1=0->addB([k,X1,Y1],P1,P);addB([K,X1,Y1],P1,P));
	K=k,Y2 is Y+ 1,
	in(X1,Y2),not(elem([_,X1,Y2],B)),not(elem([_,X1,Y2],W)),
	remove([_,X,Y],B,P1),addB([k,X1,Y2],P1,P)).
%********************** Draws Current Position ***************************
drawPos:-pos(K,B,W),drawColor(b,B),drawColor(w,W).

drawColor(C,[]). 
drawColor(C,[H|B]):-drawColor(C,B),elemOfelem(K,X,Y,H),(K=m->draw_Pul(C,X,Y);draw_King(C,X,Y)).
%********************** elem(X,Y) X is element of Y***********************
elem(H,[H|L]).
elem(A,[H|L]):-elem(A,L).
%********************** Removes A element from list P: Result Q **********
remove(A,[A|P],P).
remove(A,[H|P],[H|Q]):-remove(A,P,Q).
%********************** Adds element in the begining of the list *********
addB(A,P,[A|P]).
%********************** Takes the Ordered pair****************************
elemOfelem(C,X,Y,[C,X,Y]).
%********************* Eval **********************************************

evalB(0,[]):-!.
evalB(P,[H|L]):-elemOfelem(K,X,Y,H),(K=m->D is Y + G_Val;D is 7 + G_Val),
	evalB(Q,L),P is Q+D.
evalW(0,[]):-!.
evalW(P,[H|L]):-elemOfelem(K,X,Y,H),
	(K=m->D is 8- Y + G_Val;D is 8 + G_Val),
	evalW(Q,L),P is Q+D.
eval([],W,-2048).
eval(B,[],2048).
eval(B,W,X):-evalB(P,B),evalW(Q,W),X is P- Q.

isFinal([],W,-2048).
isFinal(B,[],2048).

stepW1(W,B):-elem(Z,B),elemOfelem(K,X,Y,Z),
	elem(T,[1,-1]),X1 is X+T,Y1 is Y- 1,(
	in(X1,Y1),not(elem([_,X1,Y1],B)),not(elem([_,X1,Y1],W));
	K=k,Y2 is Y+ 1,
	in(X1,Y2),not(elem([_,X1,Y2],B)),not(elem([_,X1,Y2],W))).

isDrawW(B,W,X):- not(stepW1(B,W)),not(can(W,B,W)).
%*************************************************************************


